% Arquivo para o Treinamento da Rede Neural com os Dados do Controlador PID
% O metodo usado  de Backpropagation do erro
% A arquitetura neural utilizada est disposta da seguinte maneira: 
% 3 neurnios na primeira camada, 20 neurnios na escondida e 1 na ultima 
% camada. A funo de ativao da camada escondida  tangente sigmoidal e  
% da camada de saida Logaritmo Sigmoidal.
% Os pesos Treinados so salvados no arquivo pesos.mat para logo ser usado
% no controle neural
% Aluno: Edgar Amaya Simen Matricula: 07/11951
% Prof.: Dr. Alberto Jose Alvares
% Curso: Topicos Avanados de Sistemas Mecatronicos
clc
clear all
alpha=0.01; % Fator de Apredizagem
load data; % Carregando a data de conhecimento para a RN na forma de vetor 
load pesos;
sp = VtrFy32Sp(:,1:270); % Vetor de dados do Set Point
pv = VtrTit32Ai(:,1:270); % Vetor de dados Variavel do Processo Tit32Ai
mv = VtrFy32Ao(:,1:270); % Vetor de dados Variavel de Controle Fy32Ao
y(1) = mv(1); % valor antigo mv(k-1)
y(2) = mv(2); % valor antigo mv(k-2)
for k=3:270
    ep(k) = sp(k)-pv(k);
    x = [y(k-1) y(k-2) ep(k)]';
    %--------------------- Saida das Neuronas Ocultas ---------------------
    Zin = V*x;
    Z = tansig(Zin+Vo);
    %-------------------------- Saida da Rede -----------------------------
    Yin = W'*Z;
    Y = logsig(Yin+Wo); %Se as Saidas so nodos
    %--------------- Atualizando os Pesos da Camada de Saida --------------
    y(k) = Y;
    e = mv(k)- 100*y(k);
    delta = e*dlogsig(Yin,Y); %Se as Saidas so Neuronas                 
    AW = alpha*delta*Z;
    AWo = alpha*delta;
    W = W + AW;
    Wo = Wo + AWo;
    %----------------- Atualizando os Pesos da Camada Oculta --------------
    deltainJ = delta*W;
    deltaJ = deltainJ.*dtansig(Zin,Z);  
    AV = alpha*deltaJ*x';
    AVo = alpha*deltaJ;
    V = V + AV;                    
    Vo = Vo + AVo;
    ee(k-2)=e;
end
save pesos V Vo W Wo ee
maximo = max(ee(:,100:250)); % maximo valor do erro de treinamento
minimo = min(ee(:,100:250)); % minimo valor do erro de treinamento
dif = maximo - minimo; 
plot(0:268,ee) % Grafico do erro en funo do Nro de Muestras.